﻿using System.ComponentModel;
using System.Windows;
using System.Windows.Data;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            #region 직원 리스트를 생성한다.

            EmployeeList employeeList = new EmployeeList();

            Employee employee1 = new Employee();

            employee1.ID          = 52590;
            employee1.Name        = "Sathish";
            employee1.Designation = "Developer";            

            employeeList.Add(employee1);

            Employee employee2 = new Employee();

            employee2.ID          = 52592;
            employee2.Name        = "Karthick";
            employee2.Designation = "Developer";            

            employeeList.Add(employee2);

            Employee employee3 = new Employee();

            employee3.ID          = 52593;
            employee3.Name        = "Raja";
            employee3.Designation = "Manager";            

            employeeList.Add(employee3);

            Employee employee4 = new Employee();

            employee4.ID          = 12778;
            employee4.Name        = "Sumesh";
            employee4.Designation = "Project Lead";            

            employeeList.Add(employee4);

            Employee employee5 = new Employee();

            employee5.ID          = 12590;
            employee5.Name        = "Srini";
            employee5.Designation = "Project Lead";            

            employeeList.Add(employee5);
            
            #endregion

            this.employeeDataGrid.ItemsSource = employeeList;

            #region 책 리스트을 생성한다.

            BookList bookList = new BookList();

            Book book1 = new Book();

            book1.ISBN   = 582912;
            book1.Title  = "C#";
            book1.Author = "James";

            bookList.Add(book1);

            Book book2 = new Book();

            book2.ISBN   = 174290;
            book2.Title  = "WPF";
            book2.Author = "Smith";

            bookList.Add(book2);

            Book book3 = new Book();

            book3.ISBN   = 095177;
            book3.Title  = ".NET";
            book3.Author = "Robert";

            bookList.Add(book3);

            Book book4 = new Book();

            book4.ISBN   = 112275;
            book4.Title  = "Java";
            book4.Author = "Steve";

            bookList.Add(book4);

            Book book5 = new Book();

            book5.ISBN   = 998721;
            book5.Title  = "COBOL";
            book5.Author = "John";

            bookList.Add(book5);

            #endregion

            this.bookDataGrid.ItemsSource = bookList;
        }         

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 직원 내보내기 버튼 클릭시 처리하기 - exportEmployeeButton_Click(sender, e)

        /// <summary>
        /// 직원 내보내기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void exportEmployeeButton_Click(object sender, RoutedEventArgs e)
        {
            ExcelExportHelper<Employee, EmployeeList> helper = new ExcelExportHelper<Employee, EmployeeList>();

            helper.List = employeeDataGrid.ItemsSource as EmployeeList;

            helper.Generate();
        }

        #endregion
        #region 책 내보내기 버튼 클릭시 처리하기 - exportBookButton_Click(sender, e)

        /// <summary>
        /// 책 내보내기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void exportBookButton_Click(object sender, RoutedEventArgs e)
        {
            ExcelExportHelper<Book, BookList> helper = new ExcelExportHelper<Book, BookList>();

            ICollectionView collectionView = CollectionViewSource.GetDefaultView(this.bookDataGrid.ItemsSource);

            helper.List = collectionView.SourceCollection as BookList;

            helper.Generate();
        }

        #endregion
    }
}